<?xml version="1.0" encoding="UTF-8"?>
<xs:schema version="1.0"
  
  xmlns:xs="http://www.w3.org/2001/XMLSchema">

<xs:complexType name="domain" final="#all">
       <xs:sequence>
              <xs:element name="projects" type="project" minOccurs="0" maxOccurs="unbounded">
              </xs:element>
              <xs:element name="tasks" type="task" minOccurs="0" maxOccurs="unbounded">
              </xs:element>
              <xs:element name="users" type="user" minOccurs="0" maxOccurs="unbounded">
              </xs:element>
      </xs:sequence>
</xs:complexType>

<xs:simpleType name="role">
  <xs:restriction base="xs:string">
     
    <xs:enumeration value="USER"/>
 
    <xs:enumeration value="ADMIN"/>
  </xs:restriction>
</xs:simpleType>

<xs:complexType name="abstractEntity" abstract="true">
       <xs:sequence>
              <xs:element name="id" type="xs:string" minOccurs="0">
              </xs:element>
      </xs:sequence>
</xs:complexType>

<xs:complexType name="project" final="#all">
   <xs:complexContent>
    <xs:extension base="abstractEntity">
      <xs:sequence>
              <xs:element name="name" type="xs:string" minOccurs="0">
              </xs:element>
              <xs:element name="description" type="xs:string" minOccurs="0">
              </xs:element>
              <xs:element name="userId" type="xs:string" minOccurs="0">
              </xs:element>
      </xs:sequence>
    </xs:extension>
  </xs:complexContent>
</xs:complexType>

<xs:complexType name="session" final="#all">
   <xs:complexContent>
    <xs:extension base="abstractEntity">
      <xs:sequence>
              <xs:element name="timestamp" type="xs:long" minOccurs="0">
              </xs:element>
              <xs:element name="userId" type="xs:string" minOccurs="0">
              </xs:element>
              <xs:element name="signature" type="xs:string" minOccurs="0">
              </xs:element>
      </xs:sequence>
    </xs:extension>
  </xs:complexContent>
</xs:complexType>

<xs:complexType name="task" final="#all">
   <xs:complexContent>
    <xs:extension base="abstractEntity">
      <xs:sequence>
              <xs:element name="name" type="xs:string" minOccurs="0">
              </xs:element>
              <xs:element name="description" type="xs:string" minOccurs="0">
              </xs:element>
              <xs:element name="userId" type="xs:string" minOccurs="0">
              </xs:element>
      </xs:sequence>
    </xs:extension>
  </xs:complexContent>
</xs:complexType>

<xs:complexType name="user" final="#all">
   <xs:complexContent>
    <xs:extension base="abstractEntity">
      <xs:sequence>
              <xs:element name="login" type="xs:string" minOccurs="0">
              </xs:element>
              <xs:element name="passwordHash" type="xs:string" minOccurs="0">
              </xs:element>
              <xs:element name="email" type="xs:string" minOccurs="0">
              </xs:element>
              <xs:element name="fistName" type="xs:string" minOccurs="0">
              </xs:element>
              <xs:element name="lastName" type="xs:string" minOccurs="0">
              </xs:element>
              <xs:element name="middleName" type="xs:string" minOccurs="0">
              </xs:element>
              <xs:element name="role" type="role" minOccurs="0">
              </xs:element>
              <xs:element name="locked" type="xs:boolean" minOccurs="0">
              </xs:element>
      </xs:sequence>
    </xs:extension>
  </xs:complexContent>
</xs:complexType>

</xs:schema>